
/***********************************************************************
*                           PUZZ . C                                   *
**--------------------------------------------------------------------**
*  Utilitaire de STAGE MAPPING pour MKID et autres jeux.	       *
*  Permet de placer les dcors du jeux et d'en crer     	       *
*  ainsi les tables.						       *
**--------------------------------------------------------------------**
*  Auteur	    : VERDONCK JOEL pour I.O.D & F.U.C                 *
*  Dvelopp le     :  4/09/1990                                       *
*  Dernie MAJ      : 15/12/1993                                       *
**--------------------------------------------------------------------**
*  Modle mmoire   : MEDIUM-HUGE-LARGE-EXTRA LARGE-OBESE              *
**--------------------------------------------------------------------**/

extern unsigned _stklen = 24000U;
#include <iodgrfx.h>
//	structure du header pour le fichier projet

typedef struct {
		BYTE tab_long;		// nombre de pages au total = nombre d'octets par ligne / 20 (20 octets par salles)
		int  bytes_perline;   	// nombre de bytes pour une ligne de tab_long pages
		int  nb_lignes;         // nombre de lignes de range de bytes_perline octets
		BYTE name_image[11];	// nom des fichiers image du projet
		BYTE type_ima;		// format d'image 0 = GE5 (MSX)
					//		  1 = SR5
					//		  2 = SRB (screen 11)
					//                3 = PCX (PC)
		BYTE num_pal;		// Numero de palette pour les fichier SRB SR5
		BYTE finesse;		// finesse des dgrads
		} PROJET_STR;
/*-- Prototypes gnraux			    ------------------*/
BYTE bloc_demande (int x,int y,char entete[8],char choix[8] [9],BYTE nb_ligne);
void message_off(int x);
void clignote (void);
void restore_pat (int x_old,int y_old);
void choix_utilisateur(void);
void restore_page (int num_page,int offcet);
int save_stg(char nom[11]);
int load_stg(char nom[11]);
void color_menu(void);

/*-- Rfrences globales	 		    ------------------*/

BYTE page;			//	page ou l'on travaille
PROJET_STR projet_head;
BYTE savepat[70];               // buffer de sauvegarde du pattern
char name[11];			// nom du stg (nom du projet)
int num_page;			// numero de la salle actuelle
unsigned char *XY_TAB;
int offcet;


/*************************************************************************
*	Ralise une temporisation.					 *
**----------------------------------------------------------------------**/

void tempo (unsigned int temporisation)
{
int i;
// 	si appui sur une touche, on sort

do
	{
	waitvsync();
	i++;
	}
while ( (i<=temporisation) && (!kbhit()) );
}






/*************************************************************************
*	envois un message.						 *
**----------------------------------------------------------------------**/
void message (BYTE *mess)
{
GrafPrintf (20,193,245,0,"%s",mess);
}

/*************************************************************************
*	affiche le bandeau.						 *
**----------------------------------------------------------------------**/
void message_off(int x)
{
GrafPrintf(184,193,0,253,"POS:%4d PAGE:%3d",(num_page*20)+offcet+x/16,num_page);
}

/*************************************************************************
*	fait clignoter un ok.						 *
**----------------------------------------------------------------------**
*     Entre: 								 *
**----------------------------------------------------------------------**/

void clignote (void)
{
do	{
	GrafPrintf (70,193,0,245,"OK? Y/N");
	delay (100);
	GrafPrintf (70,193,0,0,"        ");
	delay (150);
	}while (!kbhit());
}

/*************************************************************************
*	restore le pattern qui tait sous le curseur.			 *
**----------------------------------------------------------------------**/
void restore_pat (int x_old,int y_old)
{
int ix,iy,i;

//	restore l'ancien pattern

i=0;

for (ix=x_old;ix<=x_old+15;ix++)
	{
	setpix(ix,y_old,savepat [i++]);
	setpix(ix,y_old+15,savepat [i++]);
	}
for (iy=y_old;iy<=y_old+15;iy++)
	{
	setpix(x_old,iy,savepat [i++]);
	setpix(x_old+15,iy,savepat [i++]);
	}

}

/*************************************************************************
*	sauvegarde le pattern qui sera sous le curseur.			 *
**----------------------------------------------------------------------**/

void save_pat (int x,int y)
{
int ix,iy,i;
//	sauvegarde le cadre du nouvel emplacement
i=0;
for (ix=x;ix<=x+15;ix++)
	{
	savepat [i++] = getpix(ix,y);
	savepat [i++] = getpix(ix,y+15);
	}
for (iy=y;iy<=y+15;iy++)
	{
	savepat [i++] = getpix(x,iy);
	savepat [i++] = getpix(x+15,iy);
	}

}

/*************************************************************************
*	dplace le curseur et rtablit le pattern.			 *
**----------------------------------------------------------------------**/


void choixpat (int x,int y,int x_old,int y_old)
{

int ix,iy,i;

//	restore l'ancien pattern
	restore_pat (x_old,y_old);

//	sauvegarde le cadre du nouvel emplacement
	save_pat(x,y);

boxline (x,y,x+15,y+15,254);
}




/*************************************************************************
*	Routine de demande alphanumrique utilisateur (8 carac).	 *
**----------------------------------------------------------------------**/

int demande_alpha (int x,int y,int nbcarac,BYTE texte[16],BYTE entree[8])
{
BYTE touche;
int i,nb_lu,n;
int xe,ye;			// coordonnes de fin
int curseur_debut;		// coordonne de dbut du curseur
int curseur_end;		// coordonnes de fin du curseur
BYTE dra=0;			// drapeau pour sortir de la boucle si appui sur esc
BYTE ligne[8];			// ligne intermdiaire rentre
int xs,ys;			// utiliss lors de la sauvegarde

// 	init gen
nb_lu=0;
curseur_debut=x+4+(strlen(texte)*8)+4;
curseur_end=curseur_debut+(nbcarac*8);
xe=curseur_end+8;
ye=y+18;
strcpy (entree,"        ");

//	cadre plein
boxfill (x,y,xe,ye,252);
//	demande
GrafPrintf (x+4,y+6,253,250,texte);
// 	contours avec reflets

Line (x,y,xe,y,253);
Line (x,y,x,ye,253);
Line (xe,y,xe,ye,251);
Line (x,ye,xe,ye,251);

//	cadre blanc et bleu de la slection

boxfill (curseur_debut-1,y+5,curseur_end+1,ye-5,252);
boxline(curseur_debut-4,y+2,curseur_end+4,ye-2,250);

//

i=0;
do
	{
	PrintChar ('_',curseur_debut+(8*i),y+6,252,253);
	touche=getche();

	//	si pas ret et bs et esc et est un alpha

	if ( (touche != 13) && (touche!=8) && (touche != 27) &&
	      ( ((touche >='a') && (touche <='z')) ||
		((touche >='0') && (touche <='9')) ||
		((touche >='A') && (touche <='Z')) ) )
		{
		GrafPrintf (curseur_debut+(8*i),y+6,252,253,"%c",touche);
		//	retirer le chiffre du code entr
		ligne[nb_lu++]=touche;
		i++;
		}
	      else
		{
		switch (touche) {
			case 27:
				dra=1;
				break;
			case 13:
				i=nbcarac;
				break;
				}
		}

	}while ( (i<=nbcarac-1) && (dra==0) );

//	return code

switch (dra) {
	case 0:		// entre correcte
		strncpy (entree,ligne,nb_lu);
		entree [nb_lu]='\0';
		return (0);
	case 1:         // appui sur esc
		return (1);
	     }
return(0);
}


/*************************************************************************
*	Routine de demande numrique utilisateur.			 *
**----------------------------------------------------------------------**/

int demande_num (int nbcarac,BYTE texte[16])
{
BYTE touche[1];
int numero,i,nb_lu,n;
BYTE num[4]={0,0,0,0}; // va contenir tous les codes ascii des diffrents chiffres entrs
int base[4]={1,10,100,1000};

touche [1]='\0';
do
{
nb_lu=0;

//	on affiche la demande et son cadre

boxfill (20+(strlen(texte)*8)+8,193,20+(strlen(texte)*8)+8+(nbcarac*8),200,245);
GrafPrintf (20,193,253,0,texte);

//	on rcupre le numro demand caractre par caractre

numero=0;
i=0;
do
	{
	PrintChar ('*',20+(strlen(texte)*8)+(8*i)+8,193,0,245);
	touche[0]=getche();

	//	si pas ret et bs et esc alors c'est un nombre

	if ( (touche[0] != 13) && (touche[0]!=8) && (touche[0] != 27)
		&& (touche [0] >='0') && (touche[0]<='9') )
		{
		GrafPrintf (20+(strlen(texte)*8)+(8*i)+8,193,0,245,touche);
		//	retirer le chiffre du code entr
		num[i++]=(touche[0]-'0');
		nb_lu++;	// nombre de caractres lus
		}
	else
		{
		if (touche[0] == 13)  // ret on finit
			i=nbcarac;
		if (touche[0] == 27)  // esc on sort et on retourne -1
			{
			i=nbcarac;
			numero=-1;
			}
		if (touche[0] == 8)  // backspace
			{
			if (i>0)
				{
				PrintChar (' ',20+(strlen(texte)*8)+(8*i)+8,193,0,245);
				i--;
				nb_lu--;
				}
			}
		}
	}
while (i<=nbcarac-1);

GrafPrintf (20,193,0,0,  "                  ");

//	validation si return et pas esc

 if ((numero>=0) && (touche[0]!=27) )
 {
   do
     {
      do
	{
		//	fait clignoter ok

		GrafPrintf (20,193,0,245,"OK RET KO BS");
		tempo(20);
		GrafPrintf (20,193,0,0,  "              ");
		tempo(20);
	}while (!kbhit());
	touche[0]=getche();
     } while ( (touche[0]!=13) && (touche[0]!=8) && (touche[0]!=27));
   //	on convertit la chaine des caractres entr en un entier
   numero=0;
   i=nb_lu-1;
   n=0;
   do{
     numero += (int) ( num[i]*base[n++]);
     i--;
     }while ((num[i]!=0) && (i>=0));
   }
   //	regarde si appui sur esc lors de la validation

   if (touche[0]==27)
	numero=-1;

}while ( (touche[0]!=27) && (touche[0]!=13) );
//	efface le texte

return (numero);
}


/*************************************************************************
*	restore la page courante.					 *
**----------------------------------------------------------------------**/
void restore_page (int num_page,int offcet)
{
int x,y;
BYTE num_case;
int x_case,y_case;
BYTE page;

for (y=0;y<=11;y++)
{
	for (x=0;x<=19;x++)
	{
	num_case= XY_TAB [ ( (num_page*20) + x+offcet) + (y*projet_head.bytes_perline)];
	   if (num_case!=255)
		{
		//	dcriptage des infos
		x_case=(int) ( ((num_case&0xf0)>>4)*16);
		y_case=(int) ( (num_case&0x0f)*16);
		if (y_case>=12*16)
			{
			y_case=0;
			page=3;
			}
		else
			page=2;
		blockmove (page,x_case,y_case,0,x*16,y*16,16,16,NULL);
		}
	   else
		//	bloc de noir
		blockmove (2,256,0,0,x*16,y*16,16,16,NULL);

	}

}
}
/*************************************************************************
*	Routine de sauvegarde des diffrents fichiers stg.		 *
**----------------------------------------------------------------------**/
int save_stg(char nom[11])
{
char nam[20];
char touche;
int handle;
char headr [8];

//	fichier coordonnes
strcpy (nam,"STG\\");
strcat (nam,nom);
strcat (nam,".STG");
_fmode=O_BINARY;
do
{
 if ((handle = creatnew(nam,0)) ==-1)
 {
 message("OVERWRITE (Y/N)");
 touche=getche();
			if (toupper(touche)=='Y')
				{
				if ( (unlink (nam))==-1)
					{
					message ("CAN'T KILL STG");
					getche();
					return(1);
					}
				}
 }
}while (handle==-1);

message ("SAVE SPG       ");
write(handle,headr,7);
write(handle,XY_TAB,projet_head.bytes_perline*12);
close (handle);

//	fichier ID
strcpy (nam,"ID\\");
strcat (nam,nom);
strcat (nam,".ID");
message ("SAVE ID       ");
_fmode=O_BINARY;
do
{
if ( (handle = creatnew(nam,0))==-1)
	{
	if ( (unlink (nam))==-1)
		{
		message ("CAN'T KILL ID");
		getche();
		return(1);
		}
	}
}while (handle==-1);

 write(handle,&projet_head,sizeof (PROJET_STR));
 close (handle);
return (0);
}


/*************************************************************************
*	Routine de chargement fichiers STG.				 *
**----------------------------------------------------------------------**
*     Entre: nom significatif du projet				 *
**----------------------------------------------------------------------**/

int load_stg(char nom[11])
{
char nam[20];
int i;
int handle;
char headr [8];

strcpy (nam,"ID\\");
strcat (nam,nom);
strcat (nam,".ID");
_fmode=O_BINARY;

if ((handle = open (nam,O_RDWR)) ==-1)
	{
	message("PAS D'ID !");
	getche ();
	projet_head.tab_long=26;		// 26 pages horizontales (25,6)
	projet_head.bytes_perline=512;     	// 512 octets pour une ligne traversant 20 pages
	projet_head.type_ima=0;			// format d'image en GE5 (MSX)
	strcpy (projet_head.name_image,"");
	}
     else
	{
	read(handle,&projet_head,sizeof (PROJET_STR));
	close (handle);
	}

strcpy (nam,"STG\\");
strcat (nam,nom);
strcat (nam,".STG");
if ((handle = open (nam,O_RDONLY)) ==-1)
	{
	message("CAN'T OPEN FILE !");
	getche ();
	return(1);
	}
message ("READING STG");
read(handle,headr,7);
read(handle,XY_TAB,projet_head.bytes_perline*12);
close (handle);
return(0);
}




/*************************************************************************
*	Routine de chargement des diffrents fichiers images.		 *
**----------------------------------------------------------------------**
*     Entre: nom significatif du projet				 *
**----------------------------------------------------------------------**/

void gen_load (BYTE arg1[11],
	       BYTE demande_pal) // demande_pal =1 si on demande la palette et
				 // la finesse des dgrads
{
BYTE nam[20];                   // variable intermdiaire
char pal[8] [9] ={"0       ",   // message afficher lors du choix de la palette
		  "1       ",
		  "2       ",
		  "3       ",
		  "4       ",
		  "5       ",
		  "6       ",
		  "7       "};
BYTE choix;
BYTE finesse;

	switch (projet_head.type_ima)
		{
		case 0:
			strcpy (nam,"GE5\\");
			strcat (nam,arg1);
			strcat (nam,".GE5");
			Bload5(nam,2,0,colormap,1);
			break;
		case 1:
			strcpy (nam,"SR5\\");
			strcat (nam,arg1);
			if (demande_pal)
			{
			   if ((choix=bloc_demande (128,36,"PALETTE:",pal,7)) != 255)
				{
				BloadS5(nam,2,0,colormap,1,choix);
				projet_head.num_pal=choix;
				}
			}
			else
			{
			if (!demande_pal)
				BloadS5(nam,2,0,colormap,1,projet_head.num_pal);
			}
			break;

		case 2:
			strcpy (nam,"SRB\\");
			strcat (nam,arg1);
			if (demande_pal)
			{
			  if ((choix=bloc_demande (128,36,"PALETTE:",pal,7)) != 255)
				{
				if ((finesse=bloc_demande (128,36,"FINESSE:",pal,3)) != 255)
					{
					BloadSB(nam,2,0,colormap,1,choix,finesse);
					projet_head.num_pal=choix;
					projet_head.finesse=finesse;
					}
				}
			}
			else
			{
			if (!demande_pal)
				BloadSB(nam,2,0,colormap,1,projet_head.num_pal,projet_head.finesse);
			}
			break;
		case 3:
			strcpy (nam,"PCX\\");
			strcat (nam,arg1);
			strcat (nam,".PCX");
			V256PCX(nam,2,0,colormap,1);
		}
		color_menu();

}







/*************************************************************************
*	Routine d'un menu de choix de fichier diverse nature.		 *
**----------------------------------------------------------------------**
*     Entre: x,y,message d'entte,objet de recherche + path		 *
*     Sortie: le nom significatif du stage				 *
*     retourne 0 si appui sur esc 1 si validation correcte		 *
*									 *
*     Recherche les fichiers correspondants  la demande des carac	 *
*     gnriques, les affiche ds un menu pull down. Et en permet 	 *
*     la slection via up down return ou space				 *
**----------------------------------------------------------------------**/
int menu (int x,int y,char nom[11],char entete[8],char path[20])
{
int i,barre;
int indice;			// indice de retour dans la table menu_tab
char menu_tab[32] [9];          // recoit tous les noms lus (32 max)
char touche;                    // touche appuie
int nb_lus;			// nombre de fichiers trouvs (max 128)
int compt;			// compteur par 8 fichiers
int nb_ligne;			// nombre de ligne affichable  l'cran
struct ffblk ffblk;		// struct de renseignements sur les fich trouvs
int done;			// flag de fin de recherche
int nombre_carac;		// variable inter
nb_lus=0;

//	recherche des fichiers concerns

//	recherche du permier fichier si il existe

if ((done=findfirst (path,&ffblk,0))==-1)
	{	// pas de fichier  ce nom
	message ("NO FILE FOUND !");
	getche();
	}
	else
	{	// recherche des autres fichiers
	nombre_carac=strstr(ffblk.ff_name,".")-ffblk.ff_name;

	//  regarde si il n'y a pas de type
	if (nombre_carac>8)
		nombre_carac=8;
	//  copie le nom de fichier ds la table
	strncpy(menu_tab[nb_lus],ffblk.ff_name,nombre_carac);
	menu_tab[nb_lus] [nombre_carac]='\0';
	nb_lus++;
	//	recherche des fichiers suivants les caractres gnriques
	while (!( done=findnext(&ffblk) ))
		{
		//  regarde le nb de carac jusqu'au nom de type

		nombre_carac=strstr(ffblk.ff_name,".")-ffblk.ff_name;
		//  regarde si il n'y a pas de type
		if (nombre_carac>8)
			nombre_carac=8;
		//  copie le nom de fichier ds la table
		strncpy(menu_tab[nb_lus],ffblk.ff_name,nombre_carac);
		menu_tab[nb_lus] [nombre_carac]='\0';
		nb_lus++;
		}
	}

if (nb_lus>0)	//  si il y a des fichiers alors on les listes et on les choisis
{
  compt=0;
  barre=0;
  indice=0;			// variable d'indice pour le nom  choisir ds menu_tab

//	dessin des cadres et enttes

  boxfill (x,y,x+12+(8*8),y+16+(9*8),252);
  Line (x,y,x+12+(8*8),y,253);
  Line (x,y,x,y+16+(9*8),253);
  Line (x+12+(8*8),y,x+12+(8*8),y+16+(9*8),251);
  Line (x,y+16+(9*8),x+12+(8*8),y+16+(9*8),251);
  GrafPrintf (x+6,y+2,253,250,"%s",entete);
  boxline (x+2,y+10,x+10+(8*8),y+14+(9*8),250);


  do
  {
  // affichage des diffrents lments

  if (nb_lus>=8)		// nombre de lignes  afficher
	nb_ligne=7;
     else
	nb_ligne=nb_lus-1;
   for (i=0;i<=nb_ligne;i++)
	{

	if (barre!=i)
		GrafPrintf (x+6,i*9+y+12,253,252,"%s",menu_tab[i+compt]);
	else
		GrafPrintf (x+6,i*9+y+12,252,253,"%s",menu_tab[i+compt]);
	}
	touche=getche();

	//	on regarde si il s'agit d'une touche tendue

	if (touche == 0x00)
		touche=getche();

	//	on ragit suivant la touche enfonce
	switch (touche) {
		case (0x48):	// up
			if (indice-1>=0)
				{
				indice--;
				if (barre-1>=0)
					barre--;
				if ( (barre==0) && (compt-1>=0) )
					compt--;
				}
				break;
		case (0x50):	// down
			if (indice+1<=nb_lus-1)
				{
				indice++;
				if ( (barre+1<=7) && (barre+1<nb_lus) )
					barre++;
				if( (indice>7) && (indice<nb_lus) )
					compt++;
				}
				break;
			}
   //	sortie si esc ou space ou return enfonc
   } while ( (touche!=27) && (touche !=13) && (touche !=0x20) );


//	return code ?

  if (touche==27)
		return (1);	// code d'abandon
		else
		{
		//	retourne le nom du fichier sans extension.
		strcpy (nom,"       ");
		nombre_carac=strlen(menu_tab[indice]);
		if (nombre_carac>8)
			nombre_carac=8;
		strncpy (nom,menu_tab[indice],nombre_carac);
		nom [nombre_carac]='\0';
		message (nom);
		return (0);	// code de validation correct
		}
	}
return (1);
}

/*************************************************************************
*	Routine d'un menu de choix de diverse nature.		 	 *
**----------------------------------------------------------------------**
*     Entre: x,y,message d'entte,objet de recherche + path		 *
**----------------------------------------------------------------------**/
BYTE bloc_demande (int x,int y,char entete[8],char choix[8] [9],BYTE nb_ligne)
{
int i,barre;
char touche;                    // touche appuie

barre=0;

//	dessin des cadres et enttes

  boxfill (x,y,x+12+(8*8),y+16+(9*8),252);
  Line (x,y,x+12+(8*8),y,253);
  Line (x,y,x,y+16+(9*8),253);
  Line (x+12+(8*8),y,x+12+(8*8),y+16+(9*8),251);
  Line (x,y+16+(9*8),x+12+(8*8),y+16+(9*8),251);
  GrafPrintf (x+6,y+2,253,250,"%s",entete);
  boxline (x+2,y+10,x+10+(8*8),y+14+(9*8),250);

  do
  {
   for (i=0;i<=nb_ligne;i++)
	{

	if (barre!=i)
		GrafPrintf (x+6,i*9+y+12,253,252,"%s",choix[i]);
	else
		GrafPrintf (x+6,i*9+y+12,252,253,"%s",choix[i]);
	}
	touche=getche();
	//	on regarde si il s'agit d'une touche tendue

	if (touche == 0x00)
		touche=getche();

	//	on ragit suivant la touche enfonce
	switch (touche) {
		case (0x48):	// up
				if (barre>=1)
					barre--;
				break;
		case (0x50):	// down
				if ( (barre+1<=7) && (barre+1<=nb_ligne) )
					barre++;
			}
   //	sortie si esc ou space ou return enfonc
   } while ( (touche!=27) && (touche !=13) && (touche !=0x20) );

//	efface le cadre en noir
  boxfill (x,y,x+12+(8*8),y+16+(9*8),0);
//	return code ?
if (touche == 27)
	return (255);	// code abandon
	else
	return (barre); // retourne le choix
}




/*************************************************************************
*	Changement des palettes de couleurs pour le menu.		 *
**----------------------------------------------------------------------**
*     Entre : rien							 *
**----------------------------------------------------------------------**/

void color_menu(void)
{
int i;
BYTE color;

for (i=225,color=0;i<=240;i++,color++)
	rgbchange (i,color*4,0,0);  			// dgrad rouge sur 32 couleurs
							// couleurs 225  255
for (i=255,color=0;i>=240;i--,color++)
	rgbchange (i,color*4,0,0);

rgbchange (0,0,0,0);					// couleur 0 = noir
rgbchange (250,0,0,28);					// bleu fonc
rgbchange (251,28,28,28);				// gris fonc
rgbchange (252,32,32,32);				// gris clair
rgbchange (253,63,63,63);       			// blanc
rgbchange (254,48,0,0);                                 // rouge
rgbchange (255,48,48,48);				// gris
}



/*************************************************************************
*	Routine principale du choix utilisateur.			 *
**----------------------------------------------------------------------**
*     Entre: rien							 *
**----------------------------------------------------------------------**/
void choix_utilisateur(void)
{
int i,n,j;
int x_old,y_old;                //	ancienne coordonnes du curseur
int x,y;			//	coordonnes du curseur
BYTE touche;			//	variable intermdiaire
BYTE color=0;                   //	couleur du curseur
BYTE num_case=0;		//      numro de la case prise dans le tampon
int numero=0;  			//	variable intermdiaire
int maxpage=0;			//	nombre de page admise
BYTE dra=0;			//	si dra=1 alors on sort.
int cur0_x=160;			//	curseur de la page 0 en x
int cur0_y=80;                  //                              y
int cur2_x,cur2_y,cur3_x,cur3_y;
BYTE way=0;
BYTE plus_dra=0;		//      drapeau  savoir si on a fait un scrool VR ou pas
BYTE dodo;			//	drapeau pour savoir si il faut rafficher le bandeau ou pas
BYTE choix=0;			//	numro de retour d'1 choix multiple
BYTE copie_block [20*12+2];	//      matrice contenant les copies de blocks
				//	nb: octet 1 = nbx; octet2 = nby
				//	choix du type d'image
BYTE copie_x,copie_y;		// 	coordonnes de dpart de la copie de block
char coincoin;
char type_image [8] [9]	= {"  GE5   ",
			   "  SR5   ",
			   "  SRB   ",
			   "  PCX   ",
			   "        ",
			   "        ",
			   "        ",
			   "        "};
BYTE menu_entete [8];		//      entte de la bote de dialogue pour le choix du type d'image
BYTE menu_path [20];		//	path ds le rpertoire concernant les images
BYTE nom_stg [11];		//	variable temporaire du nom du stage

	//	initialisations
	//	---------------
num_case=0;
copie_x=0;copie_y=0;copie_block[0]=0;copie_block[1]=0;copie_block[2]=255;

cur2_x=cur3_x=cur0_x;
cur2_y=cur0_y;
cur3_y=0;

offcet=0;
x=160;x_old=160;y=80;y_old=80;                          // curseur
maxpage=projet_head.tab_long;			        // nombre de pages dispo par dfaut
memset (XY_TAB,255,sizeof(BYTE)*512*12);		// met des -1 (noir) ds toute la tble
							// 12*20 octets = 240 octets

color =0;						// couleur actuelle du curseur

setpage(1);
boxline (2,0,22,18,253);
GrafPrintf (64+20,2,253,0,"NB LIGNES :%d",projet_head.nb_lignes);
GrafPrintf (64+20,12,253,0,"OCT/LIGNE :%d",projet_head.bytes_perline);

showpage (0);setpage(0);
page = 0;
restore_page(0,0);
save_pat(x,y);
message_off(x);
//	affiche STG:
GrafPrintf (20,193,245,0,"                 ");
GrafPrintf (20,193,245,0,"STG:%s",strupr(name) );
color_menu();						// changement palette pour le menu principal

	//	choix utilisateurs principaux du logiciel
	//	-----------------------------------------
do
{
	//	animation du curseur
	dodo=1;
	do
	{
	if ((color<63) && (way==0))
		color++;
	      else
		way=1;

	if ((color>=5) && (way==1))
		color--;
	      else
		way=0;

	rgbchange (254,color,20,20);
	boxline (x,y,x+15,y+15,254);
	delay(10);
	}
	while (!kbhit());
	fflush (stdin);
	touche = getche();		// regarde si il d'agit d'un caractre
	if (touche == 0x00)		// tendu
		{
		touche=getche();
		}

	//	Diffrents choix suivant les diffrentes touches
	//	du clavier.
   switch (touche)
	{
	// changement de page pour la slection
	case '0':
		if (page !=0)
		{
		restore_pat (x,y);
		if (page==2) {cur2_x=x;cur2_y=y;}	// sauvegarde curseur
		if (page==3) {cur3_x=x;cur3_y=y;}
		showpage(0);setpage(0);
		plus_dra=0;
		x=cur0_x;y=cur0_y;
		save_pat(x,y);
		page = 0;
		dodo=0;
		}
		break;

	case '/':
		if (plus_dra==0)
		{
			for (i=0;i<=32;i+=2)
				{
				start_adr(i*80);
				waitvsync();
				}
			plus_dra=1;
		}
		else
		{
			for (i=32;i>=0;i-=2)
				{
				start_adr(i*80);
				waitvsync();
				}
			plus_dra=0;
			dodo=0;
		}
		break;

	case '2':
		if (page!=2)
		{
		restore_pat (x,y);
		if (page==0) {cur0_x=x;cur0_y=y;}
		if (page==3) {cur3_x=x;cur3_y=y;}
		showpage(2);setpage(2);
		plus_dra=0;
		x=cur2_x;y=cur2_y;
		save_pat(x,y);
		page = 2;
		}
		break;

	case '3':
		if (page!=3)
		{
		restore_pat (x,y);
		if (page==0) {cur0_x=x;cur0_y=y;}
		if (page==2) {cur2_x=x;cur2_y=y;}
		showpage(3);setpage(3);
		plus_dra=0;
		y=0;
		x=cur3_x;y=cur3_y;
		save_pat(x,y);
		page = 3;
		}
		break;

	// up
	case 0x48:
		if (y>0)
			{
			y_old=y;x_old=x;
			y-=16;
			choixpat(x,y,x_old,y_old);
			if (page==0)
				{
				cur0_x=x;cur0_y=y;
				}
			dodo=0;
			}
		break;

	// left
	case 0x4b :
		if (x>0)
			{
			x_old=x;y_old=y;
			x-=16;
			choixpat(x,y,x_old,y_old);
			if (page==0)
				{
				cur0_x=x;cur0_y=y;
				}
			}
		else
			{
			if (!( (num_page==0) && (offcet==0) ) && (page==0))
				{
				if (offcet>0)
					offcet--;
				else
					{
					num_page--;
					offcet=19;
					}
				restore_page(num_page,offcet);
				save_pat(x,y);
				}
			}
			dodo=0;
		break;

	// right
	case 0x4d :
		if( ( (x<19*16) && (page==0) ) || ( (x<15*16)&&( (page==2)||(page==3) ) )  )
			{
			x_old=x;y_old=y;
			x+=16;
			choixpat (x,y,x_old,y_old);
			if (page==0)
				{
				cur0_x=x;cur0_y=y;
				}

			}
		else	// avance d'un cran ds la tble
			{
				if ( (page==0) && (num_page<projet_head.tab_long-1) )
					{
					if (offcet<19)
						 offcet++;
						else
						 {
						 offcet=0;
						 num_page++;
						 }
					restore_page(num_page,offcet);
					save_pat(x,y);
					}
			}
			dodo=0;
		break;

	// down
	case 0x50 :
		if ( (y<(11*16)) && (page!=3) )
			{
			y_old=y;x_old=x;
			y+=16;
			choixpat (x,y,x_old,y_old);
			if (page==0)
				{
				cur0_x=x;cur0_y=y;
				}
			}
			dodo=0;
		break;

	// dessine le pattern prcdemment choisit
	// sur la case droite par rapport au curseur
	// incrmente le curseur en x.
	case 82:
		if (page==0)
			{
				blockmove (1,4,2,0,x,y, 16,16,NULL);
				save_pat(x,y);
			//	affectation dans la table
				XY_TAB[( (20*num_page ) + (x/16) + offcet ) + ((y/16)*projet_head.bytes_perline)] = num_case;

			//	dplacement du curseur

			if ( (x==19*16) && (y<11*16) )
				{
				x_old=x;y_old=y;
				y+=16;
				x=0;
				}
			      else
				{
				if ((y*16!=192-16) && (x!=19*16))
					{
					x_old=x;y_old=y;
					x+=16;
					}
				}
			if (y*16<192)
				choixpat (x,y,x_old,y_old);
			}
		dodo=0;
		break;
	// slection du pattern et copie du tampon au dessin
	case 0x20 : case 0x0d : // space ou enter
	     if (page==0)
		{    // si dans la page dessin on copie le bloc tampon  l'endroit voulu
		blockmove (1,4,2,0,x,y, 16,16,NULL);
		save_pat(x,y);
		//	affectation dans la table
		XY_TAB[( (20*num_page ) + (x/16) + offcet ) + ((y/16)*projet_head.bytes_perline)]=num_case;
		}
	     else
		{    // copie du block sur le tampon (en page 0);

		//	calcul du numro de la case du tampon
		num_case=0;
		num_case=(BYTE)  ( (x/16) << 4);
		if (page==3)
			num_case|=12;
			else
			num_case|=(BYTE) (y/16);
		//	on revient en page 0
		restore_pat(x,y);
		if (page==2) {cur2_x=x;cur2_y=y;}	// sauvegarde curseur
		if (page==3) {cur3_x=x;cur3_y=y;}
		blockmove ( page,x,y, 1,4,2, 16,16,NULL);
		showpage(0);setpage(0);
		page=0;
		x=cur0_x;y=cur0_y;
		save_pat(x,y);
		dodo=0;
		}
		break;

	// end = fin du tableau
	case 79:
		x_old=x;y_old=y;
		x=19*16;
		choixpat (x,y,x_old,y_old);
		if (page==0)
			cur0_x=x;cur0_y=y;
		break;

	// home = dbut du tableau
	case 71:
		x_old=x;y_old=y;
		x=0;
		choixpat (x,y,x_old,y_old);
		if (page==0)
			cur0_x=x;cur0_y=y;
		dodo=0;
		break;
	//	+ = on avance d'une salle en gardant l'offcet
	case '+':
		if (page==0)
		{
		if (num_page+1 <= maxpage-1)
			{
			  num_page++;
			  restore_page(num_page,offcet);
			  save_pat(x,y);
			}
		dodo=0;
		}
		break;
	//	- = on recule d'une salle en gardant l'offcet
	case '-':
		if (page==0)
		{
		if (num_page-1 >= 0)
			{
			  num_page--;
			  restore_page(num_page,offcet);
			  save_pat(x,y);
			}
		dodo=0;
		}
		break;
	// demande le numro de page
	case '*':
		if (page==0)
		{
		numero=demande_num (3,"PAGE NUMBER ?");
		if ((numero!=-1) && (numero<maxpage))
			{
			num_page=numero;
			offcet=0;
			restore_page(num_page,offcet);
			save_pat(x,y);
			}
		// contrle la validit du numro de page
		if (numero>=maxpage)
			{
			message("OVERPAGE !...");
			getche();
			}
		}
		break;

	// page up = page suprieure
	case 0x49:
		if (page==0)
		{
		if (num_page+1 <= maxpage-1)
			{
			  num_page++;
			  offcet=0;
			  restore_page(num_page,offcet);
			  save_pat(x,y);
			}
		dodo=0;
		}
		break;
	// page down page -1
	case 0x51:
		if (page==0)
		{
		if (num_page-1 >= 0)
			{
			  num_page--;
			  offcet=0;
			  restore_page(num_page,offcet);
			  save_pat(x,y);
			}
		dodo=0;
		}
		break;

	// esc = sortir avec validation
	case 0x1b:
		if (page==0) // si page = 0 alors on sort du programme
		  {
			message ("                 ");
			message ("QUIT ");
			do{	     // demande de validation
				clignote ();
				touche=getche();
			} while ( (toupper(touche)!='Y') && (toupper(touche)!='N'));
			if (toupper(touche)=='Y') // ici, on sort
				dra=1;
		   }
		 else // si esc ds une autre page alors on revient  la page 0
		   {
			restore_pat (x,y);
			showpage(0);setpage(0);
			plus_dra=0;
			x=cur0_x;y=cur0_y;
			save_pat(x,y);
			page = 0;
		   }
		break;
	// redraw
	case 'r':
			restore_page(num_page,offcet);
			save_pat(x,y);
			dodo=0;
			break;
	// f10 :clear eraser la page courante
	case 68:
			for (j=0;j<=19;j++)
			    {
			    for (i=0;i<=11;i++)
				XY_TAB[(projet_head.bytes_perline*i) + ((num_page*20)+j+offcet)]=255;
			    }
			restore_page(num_page,offcet);
			save_pat(x,y);
			break;
	// save the stage (STG)
	case 's':
			save_stg(name);
			break;
	// load the stage (STG) and image for
	case 'l':
			message ("STAGE NAME");
			if (menu (124,56,strupr(name),"*.STG","STG\\*.STG")==0)
				{
				save_pat(x,y);
				load_stg(name);
				maxpage=projet_head.tab_long; // nb de pages

				if ( (stricmp(projet_head.name_image,""))!=0)
					{
					gen_load (projet_head.name_image,0);
					showpage (0);setpage(0);				// page active 0
					plus_dra=0;
					page = 0;
					load_stg(name);
					}
				}
			restore_page(num_page,offcet);
			save_pat(x,y);
			break;
	// load the stage image
	case 'i':
			if ( (choix=bloc_demande (128,36,"PICT ID:",type_image,4)) != 255)
				{
						//	demande de quel type sera le format de l'image
						switch (choix)
							{
							case 0:
									strcpy (menu_entete,"*.GE5");
									strcpy (menu_path,"GE5\\*.GE5");
									break;
							case 1:
									strcpy (menu_entete,"*.SR5");
									strcpy (menu_path,"SR5\\*.SR5");
									break;
							case 2:
									strcpy (menu_entete,"*.SRB");
									strcpy (menu_path,"SRB\\*.SRB");
									break;
							case 3:
									strcpy (menu_entete,"*.PCX");
									strcpy (menu_path,"PCX\\*.PCX");
							}
						if ( (menu(124,56,projet_head.name_image,menu_entete,menu_path) ) ==0 )
							{
							projet_head.type_ima=choix;
							gen_load (projet_head.name_image,1);
							plus_dra=0;
							setpage(0);showpage(0);
							page = 0;
							}
							restore_page(num_page,offcet);
							save_pat(x,y);
				}
				break;
	// new projects
	case 'n':
			message ("NEW ? (Y/N)");
			touche=getche();
			if (toupper(touche)=='Y')
				{
				message ("STAGE NAME  ");
				if ( (demande_alpha(124,56,8,"STG:",strupr(nom_stg) ) ) == 0)
					{
					strcpy (name,nom_stg);
					message ("IMAGE NAME ?");
					if ( (choix=bloc_demande (128,36,"PICT ID:",type_image,4)) != 255)
						{
						//	demande de quel type sera le format de l'image
						switch (choix)
								{
								case 0:
									strcpy (menu_entete,"*.GE5");
									strcpy (menu_path,"GE5\\*.GE5");
									break;
								case 1:
									strcpy (menu_entete,"*.SR5");
									strcpy (menu_path,"SR5\\*.SR5");
									break;
								case 2:
									strcpy (menu_entete,"*.SRB");
									strcpy (menu_path,"SRB\\*.SRB");
									break;
								case 3:
									strcpy (menu_entete,"*.PCX");
									strcpy (menu_path,"PCX\\*.PCX");
								}
						if ( (menu(124,56,projet_head.name_image,menu_entete,menu_path) ) ==0 )
							{
							projet_head.type_ima=choix;
							gen_load (projet_head.name_image,1);
							setpage(0);showpage(0);	  // page active 0
							plus_dra=0;
							page = 0;
							save_pat(x,y);
							choixpat(x,y,x_old,y_old);
							}
						}
					}
					restore_page(num_page,offcet);
					save_pat(x,y);
				}
			break;
	//	copie du caractre ds le tampon x fois
	case 'd':
			if (page==0)
			{
			if ( (i=demande_num (3,"HOW MANY ?"))!=-1)
				{
				// si le nombre dpasse nboctet/ligne alors on met la valeur max
				if (i>=( projet_head.bytes_perline -( (x/16)+offcet+(num_page*20) ) ) )
					i=projet_head.bytes_perline -( (x/16)+offcet+(num_page*20) );

				   for (j=0;j<i;j++)
					XY_TAB[(x/16)+offcet+(num_page*20)+j+( (y/16)*projet_head.bytes_perline)]=num_case;
				}
				restore_page(num_page,offcet);
				save_pat(x,y);
			}
			dodo=0;
			break;
	// change le nombre d'octets par ligne
	case 'w':
			if (page==0)
			{
			 if ( (i=demande_num (4,"BYTES/LINE"))!=-1)
			   {
			      if (i<=1024)
				{
				projet_head.tab_long=i/20;
				projet_head.bytes_perline=i;
				setpage(1);
				GrafPrintf (64+20,12,253,0,"OCT/LIGNE :%d",projet_head.bytes_perline);
				setpage(0);
				}
				dodo=1;
			   }
			 }
			break;
	// change le nombre de lignes (pas encore utilis)
	case 'h':
			if (page==0)
			{
			if ((i=demande_num (4,"NBR LINES"))!=-1)
				{
				if (i<=15)
					{
					projet_head.nb_lignes=i;
					setpage(1);
					GrafPrintf (64+20,2,253,0,"NB LIGNES :%d",projet_head.nb_lignes);
					setpage(0);
					}
				}
			dodo=1;
			}
			break;
	//	a = changement du nom stage
	case 'a':
			if (!page)
			{
			message ("STAGE NAME  ");
				if ( (demande_alpha(124,56,8,"STG:",strupr(nom_stg) ) ) == 0)
					{
					strcpy (name,nom_stg);
					}
			restore_page(num_page,offcet);
			save_pat(x,y);
			dodo=1;
			}
			break;
	//	f1 dbut de block
	case 59:
			if (page==0)
				copie_x=x/16+offcet+(num_page*20);
			else
				copie_x=x/16;
			if (page==3)
				copie_y=12;
			      else
				copie_y=y/16;
			break;
	//      f2 fin de block
	case 60:
			if (page==0)
				{
				//	test si x2 =< x1 ou que y2 <= y1
				if ( ( ((x/16)+offcet+(num_page*20))>=copie_x) && ((y/16)>=copie_y) )
				   {
					//	nombre d'octets en HR
					if ( (copie_block[0] = ((x/16)+offcet+(num_page*20))-copie_x) <20)
						{
					//	nombre d'octets en VR

						copie_block[1] = (y/16)-copie_y;
						for (i=0;i<=copie_block[1];i++)
							{
							for (j=0;j<=copie_block[0];j++)
								copie_block [2+(i*20)+j]=XY_TAB [(projet_head.bytes_perline*(copie_y+i)) + (j+copie_x)];
							}
						}
					else {message ("TROP EN X");getche();}
				   }
				  else {message("ERR SAISIE");getche();}
			}
			else
				{
				if ( ((x/16)>=copie_x) && ( ((y/16)>=copie_y)||(page==3) ) )
					{
					   copie_block[0] = (x/16)-copie_x;
					   if (page==3)
						copie_block[1] = 0; // une seule ligne en page 3
					       else
						copie_block[1] = (y/16)-copie_y;

					   for (i=0;i<=copie_block[1];i++)
						{
						for (j=0;j<=copie_block[0];j++)
							{
							num_case=0;
							num_case=(BYTE)  ( (copie_x+j) << 4);
							num_case|=(BYTE) (copie_y+i);
							copie_block [2+(i*20)+j]=num_case;
							}
						}
					} else {message ("ERR SAISIE     ");getche();}
				 }
			break;
	//      f3 = copie proprement dite
	case 61:
			if (page==0)
				{
				//	dans le cas o l'on serait en block + grand que y total
				if ( (coincoin = copie_block[1]-(11-(y/16))) <0)
						coincoin=0;
				for (i=0;i<=copie_block[1]-coincoin;i++)
					{
					for (j=0;j<=copie_block[0];j++)
						XY_TAB [(projet_head.bytes_perline*(i+(y/16))) + ((num_page*20)+j+offcet+(x/16))]=copie_block [2+(i*20)+j];
					}
					restore_page(num_page,offcet);
					save_pat(x,y);
				}
			break;
	}         // fin du switch
	//	affiche le bandeau
	if (dodo && !page)
		{
		GrafPrintf (20,193,245,0,"                 ");
		GrafPrintf (20,193,245,0,"STG:%s",strupr(name) );
		}
	if (page && dodo)
		{
		GrafPrintf (20,193,245,0,"                 ");
		GrafPrintf (20,193,245,0,"IMA:%s",strupr(projet_head.name_image) );
		}
	if (!page)
		message_off(x);

 }
 while (!dra);     // si esc alors fin

//	fin du choix utilisateur

deinit();			// revient au mode texte.
}



/*--------------------------------------------------------------------*/
/*--                 PROGRAMME PRINCIPAL                            --*/
/*--------------------------------------------------------------------*/


void main(int argc,char* arg[],char *env[])
{
BYTE memoire[16000];	       	  // table contenant les adresses des patterns  afficher
unsigned int size;
int i;
//	init par dfaut
projet_head.tab_long=26;	 // 26 pages horizontales (25,6)
projet_head.bytes_perline=512;   // 512 octets pour une ligne traversant 20 pages
projet_head.nb_lignes=12;        // 12  lignes de 512 octets
projet_head.type_ima=0;		 // format d'image en GE5 (MSX)
projet_head.num_pal=0;		 // numro de palette = 0
projet_head.finesse=1;		 // finesse des dgrads
strcpy (name,"");
strcpy (projet_head.name_image,"");

XY_TAB=memoire;

//	si puzz nl alors pas de logo de dpart
if ((stricmp (arg[1],"nl")!=NULL)||(argc==0))
	{
//	page de prsentation
	ini_320200();		// 320 200 4 pages
	for (i=0;i<=768;i++)	// remise  0 de toutes les palettes
		colormap[i]=0;
	SetPalette (colormap,256);

	V256PCX("PUZZ.PCX",0,1,colormap,20);
	tempo (3000);
	fadeout(colormap,256,30);
	}
for (i=0;i<=768;i++)
	colormap[i]=0;
SetPalette (colormap,255);

ini_320200();		// 320 200 4 pages
choix_utilisateur();    // on passe aux commandes
//  affichage de la version + messages
textcolor (14);
textbackground (1);
cputs ("                  PUZZ stage builder for MKID (ROB version 1.00)                ");
textbackground (0);
puts  ("\n");
textcolor (15);
cputs ("      En cas de problme(s), vous pouvez me contacter  l'adresse indique      ");
cputs ("      dans la documentation ci-jointe (2mots.doc). Je me ferait un plaisir      ");
cputs ("      de vous rpondre.                                                         ");
puts  ("\n");
cputs ("      Merci d'utiliser PUZZ, et de m'encourager  la rdaction d'autres         ");
cputs ("      utilitaires de ce type.                                                   ");

textcolor (7);
puts  ("\n");
cputs ("                     Bonne Fte de fin d'anne 1994  tous                      ");
puts  ("\n");
cputs ("                                           Amicalement                          ");
cputs ("                                              DJO.                              ");
}